=== renderer/CMakeLists.txt ===
set(HEADERS
  dyna_gl.h
  HardwareInternal.h
)
set(CPPS
  HardwareClipper.cpp
  HardwareDraw.cpp
  HardwareGlobalVars.cpp
  HardwareInstance.cpp
  HardwareOpenGL.cpp
  HardwareBaseGPU.cpp
  HardwarePoints.cpp
  HardwareSetup.cpp
  HardwareTransforms.cpp
  lnxscreenmode.cpp
)

# These are excluded.
#opengl.cpp
#renderer.cpp
#Direct3D.cpp

add_library(renderer STATIC ${HEADERS} ${CPPS})
target_link_libraries(renderer PRIVATE
  SDL2::SDL2
  bitmap
  ddio
  mem
  misc
  rtperformance
)
