=== debian/changelog ===
descent3 (1.5.0+ds-1) unstable; urgency=low

  * Initial release. Closes: #1079369

 -- Sébastien Noel <sebastien@twolife.be>  Thu, 22 Aug 2024 12:25:17 +0200
