=== debian/control ===
Source: descent3
Section: contrib/games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, libsdl2-dev, zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://github.com/DescentDevelopers/Descent3
#Vcs-Browser: https://salsa.debian.org/games-team/descent3
#Vcs-Git: https://salsa.debian.org/games-team/descent3.git

Package: descent3
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}, game-data-packager-runtime (>= 80), descent3-data (>= 80) | game-data-packager
Description: port of the 1999 classic game Descent 3
 This is the Descent 3 open source engine by Outrage Entertainment.
 .
 In this video game, the player must control a flying ship that has
 a six degrees of freedom movement scheme, allowing the player to move
 and rotate in any 3D direction.
 .
 To make this package useful, you will need the original game data.
 You can install them by using the game-data-packager package.
