=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_LOGGER=ON

execute_after_dh_auto_build:
	chmod 644 obj-*/Descent3/netgames/*

override_dh_auto_install:
