=== debian/watch ===
version=4

opts="\
pgpmode=none,\
repack,repacksuffix=+ds,dversionmangle=s/\+ds$//,\
filenamemangle=s{Descent3-([\d\._]+)-Source}{@PACKAGE@-$1},\
searchmode=plain,\
" https://api.github.com/repos/DescentDevelopers/Descent3/releases?per_page=99 \
  https://github.com/DescentDevelopers/Descent3/releases/download/v([\d._]+)/Descent3-[\d._]+-Source@ARCHIVE_EXT@ \
  debian uupdate
