## descent3 1.6.0~20250615%2Bds

=== bitmap/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
   cfile
   ddebug
   ddio
+  logger
   mem
   misc
   stb
