=== dd_grwin32/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,8 @@
 add_library(dd_grwin32 STATIC ${HEADERS} ${CPPS})
 target_link_libraries(dd_grwin32 PRIVATE
   2dlib
-  misc
+  ddebug
+  logger
 )
 target_compile_definitions(dd_grwin32 PRIVATE DX_APP)
 target_link_libraries(dd_grwin32 PRIVATE ${DDRAW_LIBRARY})
