=== debian/watch ===
version=4

opts="\
pgpmode=none,\
repack,repacksuffix=+ds,dversionmangle=s/\+ds$//,\
mode=git,\
pretty=1.6.0~%cd,compression=xz,\
" https://github.com/DescentDevelopers/Descent3.git HEAD \
  debian uupdate

#searchmode=plain,\
#" https://api.github.com/repos/DescentDevelopers/Descent3/releases?per_page=99 \
#  https://github.com/DescentDevelopers/Descent3/releases/download/v([\d._]+)/Descent3-[\d._]+-Source@ARCHIVE_EXT@ \
