## descent3 1.6.0~20250615%2bds

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DATE_VER := $(shell echo ${DEB_VERSION} | sed 's/1\.[0-9]\.[0-9]~//; s/\+ds-[0-9]//')

%:
	dh $@

override_dh_auto_configure:
	echo -n $(DATE_VER) > git-hash.txt
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo

execute_after_dh_auto_build:
	chmod 644 obj-*/build/netgames/*

override_dh_auto_install:
